from tiles import *
from sprito import *

def cut(string, long = 34):
  if len(string) <= long:
    return [string]
  else:
    char = long
    while not string[char].isspace():char -= 1
    return [string[:char]] + cut(string[char+1:], long)

def disp(string, color = (0,0,0)):
  string = cut(string)
  for i in range (len(string)):
    draw_string(0,15*i,34*" ",(0,0,0))
    draw_string(0,15*i,string[i],color)
  for i in range(384):
    set_pixel(i,15*len(string)+3,(0,0,0))
    
class Map():
  def __init__(self, data, x = 24, y = 12):
    self.data = data
    self.tileset = [SpriteIndexed(16,16,i) for i in sprite]
    self.size = (x,y) 
  
  def set(self, data, x = 24, y = 12):
    self.data = data
    self.size = (x,y)
    
  def get(self, x, y):
    i = x + self.size[0]*y
    try:
      return self.data[i]
    except:
      return -1
      
  def draw(self):
    i = 0
    for y in range(self.size[1]):
      for x in range(self.size[0]):
        if self.data[i] != " ":self.tileset[int(self.data[i])].draw(16*x,16*y,pallet)
        i += 1

def get_key(key_old):
  key_act = -1
  while key_act == -1:
    try:
      for i in range(50):pass
    except KeyboardInterrupt:
      key_act = input("> ")
  try:
    return int(key_act)
  except:
    return key_old

def mainloop(monde):
  key = 0
  direction = 0
  x,y = 0,0
  j = [SpriteIndexed(16,16,i) for i in joueur]
  while key != 9:
    clear_screen()
    monde.draw()
    j[direction].draw(16*x,16*y,pallet)
    show_screen()
    key = get_key(key)
    if key == 1:
      x = (x,x-1)[(x!=0)*(monde.get(x-1,y) == " ")]
      direction = 2
    elif key == 3:
      x = (x,x+1)[(x!=24)*(monde.get(x+1,y) == " ")]
      direction = 3
    elif key == 5:
      y = (y,y-1)[(y!=0)*(monde.get(x,y-1) == " ")]
      direction = 1
    elif key == 2:
      y = (y,y+1)[(y!=12)*(monde.get(x,y+1) == " ")]
      direction = 0
